package subFunction;
use strict;
use base "Exporter";
use Cwd;
use DBI;
use MIME::QuotedPrint;
our @EXPORT = qw/delHash trim killprog path gdzieScript delCudzyslow delComment plikZapisz makeDir codePL delPL encode_header /;
# v2015-07-05



sub delHash { 
 my($tekst) = @_; 
 $tekst =~ s/(#|;)(.*)$//g;
 return trim($tekst);
}

sub trim($) {
 my $string = shift;
 $string =~ s/^\s+//;
 $string =~ s/\s+$//;
 return $string;
}


# killprog("x.pl", 60);
sub killprog {
   my($nprog, $life) = @_;
   my @lists = qx(ps -aux 2> /dev/null | grep '$nprog' );

   foreach my $out (@lists) { if(!($out =~ /^.*grep.*$/)) {
	$out = trim($out);
	my @tab = split(/\s+/, $out);
	my @tim = split(/\:/, @tab[9]);
	   if(@tim[0] > $life) {
		system("kill -9 ".@tab[1]." 1> /dev/null 2> /dev/null");	
	   }
   }}

 return 1;
}



sub path { 
 my($path) = @_; 
 my $pwd = trim(gdzieScript($0)) || trim(cwd)."/";
 my $domowy = qx(echo \$HOME); $domowy = trim($domowy);

 $path =~ s/^\~\//$domowy\//g;
 $path =~ s/^\.\//$pwd/g;

 return $path; 
}

sub gdzieScript {
 my($polecenie) = @_;
  my @tab = split(/\//, $polecenie);
  my $ileTAB =  @tab;
  $polecenie =~ s/@tab[$ileTAB-1]//g;
 return trim($polecenie);
}


sub delCudzyslow { 
 my($tekst) = @_; 
 $tekst =~ s/^\s+//;
 $tekst =~ s/\s+$//;
 $tekst =~ s/^"//g;
 $tekst =~ s/"$//g;
 $tekst =~ s/^'//g;
 $tekst =~ s/'$//g;
 return $tekst;
}


sub delComment { 
 my($tekst) = @_; 
   if($tekst =~ /^".+".*$/) {
	 $tekst =~ s/"\s+(#|;)(.*)$//g;
   } else {
	 $tekst =~ s/\s+(#|;)(.*)$//g;
   }
 return $tekst;
}



sub plikZapisz { 
 my($plik,$co) = @_; 
  open(UCHWYT, '>', $plik) or die "Nie można otworzyć $plik: $!"; 
  print UCHWYT $co; 
  close UCHWYT; 
}

sub makeDir {
 my($sciezka, $tworz, $chmod) = @_; 

   foreach my $ou (split( /\//, $tworz)) { if($ou) {
	$sciezka = $sciezka."/".$ou;
	   if(!( -d $sciezka)) { mkdir($sciezka); chmod(($chmod || "0755"), $sciezka); }

   }}
 return $sciezka; 
}



sub codePL {
 my($txt) = @_;
 my %code = ("ą" => "&#261;", "ć" => "&#263;", "ę" => "&#281;", "ł" => "&#322;", "ń" => "&#324;", "ó" => "&#243;", "ś" => "&#347;", "ż" => "&#378;", "ź" => "&#380;",
	"Ą" => "&#260;", "Ć" => "&#262;", "Ę" => "&#280;", "Ł" => "&#321;", "Ń" => "&#323;", "Ó" => "&#242;", "Ś" => "&#346;", "Ż" => "&#377;", "Ź" => "&#379;",);
   foreach my $k (keys %code) {
	$txt =~ s/$k/$code{$k}/g;

   }
 return $txt;
}



sub delPL {
 my($tekst) = @_; 
 my %del = ('ą' => 'a', 'ć' => 'c', 'ę' => 'e', 'ł' => 'l', 'ń' => 'n', 'ó' => 'o', 'ś' => 's', 'ż' => 'z', 'ź' => 'z', 'Ą' => 'A', 'Ć' => 'C', 'Ę' => 'E', 'Ł' => 'L', 'Ń' => 'N', 'Ó' => 'O', 'Ś' => 'S', 'Ź' => 'Z', 'Ź' => 'Z');

   foreach my $k (keys %del) { $tekst =~ s/$k/$del{$k}/g; }

 return $tekst;
}


sub encode_header {
 my $subject = shift;
 $subject = encode_qp($subject, '');
 $subject =~ s/ /_/g;
 # @TODO: split long lines
 return "=?UTF-8?Q?$subject?=";
}



1;
